<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_stats_report".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderStatsReport".
 *
 * Columns in table "provider_stats_report" available as properties of the model,
 * followed by relations of table "provider_stats_report" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $date
 * @property string $search_views
 * @property string $profile_views
 * @property string $phone_views
 * @property string $fax_views
 * @property string $email_views
 * @property string $website_views
 * @property integer $phone_calls
 * @property integer $grouped
 *
 * @property Provider $provider
 */
abstract class BaseProviderStatsReport extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_stats_report';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderStatsReport|ProviderStatsReports', $n);
    }

    public static function representingColumn()
    {
        return 'date';
    }

    public function rules()
    {
        return array(
            array('provider_id, date', 'required'),
            array('provider_id, phone_calls, grouped', 'numerical', 'integerOnly' => true),
            array('search_views, profile_views, phone_views, fax_views, email_views, website_views', 'length',
                'max' => 10),
            array('search_views, profile_views, phone_views, fax_views, email_views, website_views, phone_calls, '
                . 'grouped', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, date, search_views, profile_views, phone_views, fax_views, email_views,'
                . ' website_views, phone_calls, grouped', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'date' => Yii::t('app', 'Date'),
            'search_views' => Yii::t('app', 'Search Views'),
            'profile_views' => Yii::t('app', 'Profile Views'),
            'phone_views' => Yii::t('app', 'Phone Views'),
            'fax_views' => Yii::t('app', 'Fax Views'),
            'email_views' => Yii::t('app', 'Email Views'),
            'website_views' => Yii::t('app', 'Website Views'),
            'phone_calls' => Yii::t('app', 'Phone Calls'),
            'grouped' => Yii::t('app', 'Grouped'),
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('date', $this->date, true);
        $criteria->compare('search_views', $this->search_views, true);
        $criteria->compare('profile_views', $this->profile_views, true);
        $criteria->compare('phone_views', $this->phone_views, true);
        $criteria->compare('fax_views', $this->fax_views, true);
        $criteria->compare('email_views', $this->email_views, true);
        $criteria->compare('website_views', $this->website_views, true);
        $criteria->compare('phone_calls', $this->phone_calls);
        $criteria->compare('grouped', $this->grouped);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
